'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = polyfills;

var _transforms = require('./transforms');

var _transforms2 = _interopRequireDefault(_transforms);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function makeCompoundVisitor(babel) {
  const parts = [];
  return Object.assign((...params) => {
    parts.forEach(part => {
      part(...params, babel);
    });
  }, {
    add(part) {
      parts.push(part);
    }
  });
}

function polyfills(babel) {
  const visitor = {};
  _transforms2.default.forEach(transform => {
    Object.keys(transform).forEach(name => {
      if (visitor[name] === undefined) {
        visitor[name] = makeCompoundVisitor(babel);
      }
      visitor[name].add(transform[name]);
    });
  });

  return {
    visitor
  };
}