'use strict';

var _package = require('../package.json');

var _path = require('path');

var _babelCore = require('babel-core');

var _ = require('.');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe(_package.name, () => {
  it('should replace String.prototype.padStart with a polyfill', () => {
    const result = compile(`
      const text = 'this is a string'
      if (text.padStart('a')) {
        console.log('success')
      } else {
        console.log('failure')
      }
    `);

    expect(result).toMatchSnapshot();
  });

  it('should not try to transform the polyfills themselves', () => {
    const result = (0, _babelCore.transformFileSync)((0, _path.resolve)(__dirname, '..', 'polyfills', 'Array', 'prototype', 'find.js'), { ast: false, babelrc: false, plugins: [_2.default] }).code;
    expect(result).toMatchSnapshot();
  });
});